<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Swarm: MainWindow Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Swarm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_main_window.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-slots">Public Slots</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="class_main_window-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">MainWindow Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>The <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a> class is the window of the project. It is here that we intercept every event comming from the user.  
 <a href="class_main_window.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for MainWindow:</div>
<div class="dyncontent">
<div class="center"><img src="class_main_window__inherit__graph.png" border="0" usemap="#_main_window_inherit__map" alt="Inheritance graph"/></div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for MainWindow:</div>
<div class="dyncontent">
<div class="center"><img src="class_main_window__coll__graph.png" border="0" usemap="#_main_window_coll__map" alt="Collaboration graph"/></div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-slots"></a>
Public Slots</h2></td></tr>
<tr class="memitem:a83e1ebb3fa24a18ceab1202f79b312c0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a83e1ebb3fa24a18ceab1202f79b312c0">advance</a> ()</td></tr>
<tr class="memdesc:a83e1ebb3fa24a18ceab1202f79b312c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Call each the <a class="el" href="class_main_window.html#a83e1ebb3fa24a18ceab1202f79b312c0" title="Call each the advance() method for each item in the scene. ">advance()</a> method for each item in the scene.  <a href="#a83e1ebb3fa24a18ceab1202f79b312c0">More...</a><br /></td></tr>
<tr class="separator:a83e1ebb3fa24a18ceab1202f79b312c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a34c4b4207b46d11a4100c9b19f0e81bb"><td class="memItemLeft" align="right" valign="top"><a id="a34c4b4207b46d11a4100c9b19f0e81bb"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a34c4b4207b46d11a4100c9b19f0e81bb">MainWindow</a> ()</td></tr>
<tr class="memdesc:a34c4b4207b46d11a4100c9b19f0e81bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor of <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a>. Define the needed parameters and execute the program. <br /></td></tr>
<tr class="separator:a34c4b4207b46d11a4100c9b19f0e81bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c75b8c1c8084615b288072723ecc9a5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a0c75b8c1c8084615b288072723ecc9a5">mousePressEvent</a> (QGraphicsSceneMouseEvent *e)</td></tr>
<tr class="memdesc:a0c75b8c1c8084615b288072723ecc9a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method called with each click on the mouse. At the moment, the left click is used to add an <a class="el" href="class_entity.html" title="The Entity class is the main object of the project. Its main goal is to interact with other Entities ...">Entity</a> to the scene.  <a href="#a0c75b8c1c8084615b288072723ecc9a5">More...</a><br /></td></tr>
<tr class="separator:a0c75b8c1c8084615b288072723ecc9a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c4f542263838b9ecd06eae839a42a34"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a9c4f542263838b9ecd06eae839a42a34">keyPressEvent</a> (QKeyEvent *event)</td></tr>
<tr class="memdesc:a9c4f542263838b9ecd06eae839a42a34"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method called with each key pressed on the keyboard. At the moment, keys 1, 2, 3, 4 are used to activate or deactivate specific behaviours of the Entities. 5 is used to toggle the infect mode.  <a href="#a9c4f542263838b9ecd06eae839a42a34">More...</a><br /></td></tr>
<tr class="separator:a9c4f542263838b9ecd06eae839a42a34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75d7910a13ccc8ee60126bf7be448341"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a75d7910a13ccc8ee60126bf7be448341">eventFilter</a> (QObject *watched, QEvent *event)</td></tr>
<tr class="memdesc:a75d7910a13ccc8ee60126bf7be448341"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method used to filter and use events that passes through our <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a>. At the moment, it is used to manage the changement in size of the window.  <a href="#a75d7910a13ccc8ee60126bf7be448341">More...</a><br /></td></tr>
<tr class="separator:a75d7910a13ccc8ee60126bf7be448341"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a4962ef49205dd767d66fb8319506fa9d"><td class="memItemLeft" align="right" valign="top"><a id="a4962ef49205dd767d66fb8319506fa9d"></a>
QGraphicsView *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a4962ef49205dd767d66fb8319506fa9d">_view</a></td></tr>
<tr class="memdesc:a4962ef49205dd767d66fb8319506fa9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">View of the project, is contained in the scene and paints the Entities. <br /></td></tr>
<tr class="separator:a4962ef49205dd767d66fb8319506fa9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07f5905b7ceb2a5351af10018262f58f"><td class="memItemLeft" align="right" valign="top"><a id="a07f5905b7ceb2a5351af10018262f58f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_main_window.html#a07f5905b7ceb2a5351af10018262f58f">_infectMode</a></td></tr>
<tr class="memdesc:a07f5905b7ceb2a5351af10018262f58f"><td class="mdescLeft">&#160;</td><td class="mdescRight">bool used in mousePressEvent to add an infected <a class="el" href="class_entity.html" title="The Entity class is the main object of the project. Its main goal is to interact with other Entities ...">Entity</a> if _infectMdoe is <code>true</code>, or a non infected one if _infectMode is <code>false</code> <br /></td></tr>
<tr class="separator:a07f5905b7ceb2a5351af10018262f58f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a> class is the window of the project. It is here that we intercept every event comming from the user. </p>
<p>The <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a> class inherits QGraphicsScene and not directly QWidget because we didn't need to add a lot to the main window.</p>
<p>From here, you can add event handlers in three ways:</p>
<ul>
<li>Modifying <a class="el" href="class_main_window.html#a0c75b8c1c8084615b288072723ecc9a5" title="Method called with each click on the mouse. At the moment, the left click is used to add an Entity to...">mousePressEvent(QGraphicsSceneMouseEvent *e)</a> to add a functionality when you press a button of the mouse. At the moment, the left click is used to add an <a class="el" href="class_entity.html" title="The Entity class is the main object of the project. Its main goal is to interact with other Entities ...">Entity</a> to the scene. </li>
<li>Modifying <a class="el" href="class_main_window.html#a9c4f542263838b9ecd06eae839a42a34" title="Method called with each key pressed on the keyboard. At the moment, keys 1, 2, 3, 4 are used to activ...">keyPressEvent(QKeyEvent *event)</a> to add a functionality when you press a button of the keyboard. At the moment, keys 1, 2, 3, 4 are used to activate or deactivate specific behaviours of the Entities. </li>
<li>Modifying <a class="el" href="class_main_window.html#a75d7910a13ccc8ee60126bf7be448341" title="Method used to filter and use events that passes through our MainWindow. At the moment, it is used to manage the changement in size of the window. ">eventFilter(QObject *watched, QEvent *event)</a> to handle other events. At the moment, it is used to manage the changement in size of the window.  </li>
</ul>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a83e1ebb3fa24a18ceab1202f79b312c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83e1ebb3fa24a18ceab1202f79b312c0">&#9670;&nbsp;</a></span>advance</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MainWindow::advance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">slot</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Call each the <a class="el" href="class_main_window.html#a83e1ebb3fa24a18ceab1202f79b312c0" title="Call each the advance() method for each item in the scene. ">advance()</a> method for each item in the scene. </p>
<dl class="section see"><dt>See also</dt><dd>QTimer, <a class="el" href="class_entity.html#a5bf60514251e4ebf68055f8baacdcb34" title="Make the Entity move and calls the getFriends() &amp; behaviour() methods. Is also used to place the ceme...">Entity::advance()</a> </dd></dl>

</div>
</div>
<a id="a75d7910a13ccc8ee60126bf7be448341"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a75d7910a13ccc8ee60126bf7be448341">&#9670;&nbsp;</a></span>eventFilter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool MainWindow::eventFilter </td>
          <td>(</td>
          <td class="paramtype">QObject *&#160;</td>
          <td class="paramname"><em>watched</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QEvent *&#160;</td>
          <td class="paramname"><em>event</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method used to filter and use events that passes through our <a class="el" href="class_main_window.html" title="The MainWindow class is the window of the project. It is here that we intercept every event comming f...">MainWindow</a>. At the moment, it is used to manage the changement in size of the window. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">watched</td><td>the object which receives the event. </td></tr>
    <tr><td class="paramname">event</td><td>the event to handle.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a <code>boolean</code>, <code>true</code> if the event was handled, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="a9c4f542263838b9ecd06eae839a42a34"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c4f542263838b9ecd06eae839a42a34">&#9670;&nbsp;</a></span>keyPressEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MainWindow::keyPressEvent </td>
          <td>(</td>
          <td class="paramtype">QKeyEvent *&#160;</td>
          <td class="paramname"><em>event</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method called with each key pressed on the keyboard. At the moment, keys 1, 2, 3, 4 are used to activate or deactivate specific behaviours of the Entities. 5 is used to toggle the infect mode. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">event</td><td>the keyboard event to handle.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>Need to add a way to see which behaviour is toggled </dd></dl>

</div>
</div>
<a id="a0c75b8c1c8084615b288072723ecc9a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c75b8c1c8084615b288072723ecc9a5">&#9670;&nbsp;</a></span>mousePressEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MainWindow::mousePressEvent </td>
          <td>(</td>
          <td class="paramtype">QGraphicsSceneMouseEvent *&#160;</td>
          <td class="paramname"><em>e</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method called with each click on the mouse. At the moment, the left click is used to add an <a class="el" href="class_entity.html" title="The Entity class is the main object of the project. Its main goal is to interact with other Entities ...">Entity</a> to the scene. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">e</td><td>the mouse event to handle.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>To avoid clicking like a starcraft player micromanaging to get big groups, need to add a way to add several Entities at once. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>Swarm/<a class="el" href="mainwindow_8h_source.html">mainwindow.h</a></li>
<li>Swarm/<a class="el" href="mainwindow_8cpp.html">mainwindow.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_main_window.html">MainWindow</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
